#{extends 'common/frontend-admin.html' /}
#{set 'title'}
<h1 class="input-content">#{if model?.isCreatedMode()}Buat Halaman Baru #{/if} #{else } Edit Halaman#{/else}</h1>
#{/set}
#{common.alert /}
<div class="container">
    <div class="row">
        <div class="col-sm-10">
            <div class="card">
                <div class="ui top attached tabular menu">
                    <a class="item active" data-tab="one">Isi Halaman</a>
                    <a class="item ${model.isCreatedMode() ? "disabled" : ""}" data-tab="two">Atur Hak Akses</a>
                </div>
                <input type="hidden" id="errorMess" value="${mess}">
                <div class="ui bottom attached tab segment active" data-tab="one">
                #{doLayout /}
                </div>
                <div class="ui bottom attached tab segment" data-tab="two">
                #{cms.access-content model:model, selectedUsers:listAkses, users:usersList /}
                </div>
            </div>
        </div>
    </div>
</div>

#{set 'moreStyles'}
<style>
    .modal-open .select2-container {
        z-index: 0 !important;
    }

    .card {
        border: inherit !important;
    }
</style>
<link rel="stylesheet" href="@{'/public/assets/plugins/summernote/css/summernote-lite.css'}">
<link rel="stylesheet" type="text/css" href="@{'/public/assets/semantic/semantic.min.css'}">
<link rel="stylesheet" href="@{'/public/assets/plugins/select2/css/select2.min.css'}"/>
<link rel="stylesheet" type="text/css" href="@{'public/stylesheets/progress-bar.css'}"/>
#{/set}
#{set 'moreScripts'}
<script src="@{'/public/assets/plugins/summernote/js/summernote-lite.js'}"></script>
<script type="text/javascript" src="@{'public/javascripts/jquery.blockui.js'}"></script>
<script type="text/javascript" src="@{'public/javascripts/jquery.validate.min.js'}"></script>
<script type="text/javascript" src="@{'/public/assets/plugins/select2/js/select2.full.min.js'}"></script>
<script src="@{'/public/assets/semantic/semantic.min.js'}"></script>
<script type="text/javascript">

    let documentExtensions = ["pdf"]
    let imageExtensions = ["jpg", "jpeg", "png"]
    let acceptDocuments = generateAccept(documentExtensions)
    let acceptImages = generateAccept(imageExtensions)
    let deletedFiles = []
    const max_file_size = ${utils.cms.FileUtil.DOCUMENT_MAX_FILE_SIZE}
    const max_size_text = '${utils.cms.FileUtil.DOCUMENT_MAX_LABEL}'
    const documentExtensionText = () => documentExtensions.join(', ')

    function generateAccept(arr) {
        var accept = ''
        var glue = ''
        for (let item of arr) {
            accept += glue + '.' + item
            glue = ', '
        }
        return accept
    }

    function validDocument(ext) {
        return documentExtensions.includes(ext)
    }

    function validImage(extension) {
        return imageExtensions.includes(extension)
    }

    $(document).ready(function () {
        $('.tabular .item:not(.disabled)').tab()
        var errorMess = $('#errorMess').val();
        if (errorMess == 'visualisasitableau' || errorMess == 'akses') {
            $('.tabular.menu .item').tab('change tab', 'two');
            var tabs = $(".tabular.menu .item");
            $.each(tabs, function () {
                if ($(this).attr('data-tab') == 'two') {
                    $(this).removeClass("disabled");
                }
            });
            $(".tab.segment").each(function () {
                if ($(this).attr('data-tab') == 'two') {
                    $(this).removeClass("disabled");
                }
            });
        }
        var status = $('#statusAction').val();
    });

    function blockInsertPicture() {
        $('.summernote-wrapper').block({
            message: 'Please Wait ....<br/><br/>Uploading Image <br/><progress></progress>',
            baseZ: 2000,
            css: {
                backgroundColor: '#00000000',
                color: '#fff',
                border: "0px",
                fontSize: '20px',
                width: '50%',
            },
            overlayCSS: {
                backgroundColor: '#000000', opacity: 0.8
            }
        });
    }

    function blockDeletePicture() {
        $('.summernote-wrapper').block({
            message: '<img src="@{'public/images/busy2.gif'}" width="50" height="50" /> Please Wait .... Deleting File',
            baseZ: 2000, css: {backgroundColor: '#00000000', color: '#fff', border: "0px", fontSize: '20px'},
            overlayCSS: {backgroundColor: '#000000', opacity: 0.8}
        });
    }

    function unblockPicture() {
        $('.summernote-wrapper').unblock();
    }

    function blockPageUI() {
        $.blockUI({
            message: '<h2><img src="@{'public/images/busy2.gif'}" width="50" height="50" /> Please Wait ....</h2>',
            baseZ: 2000, css: {backgroundColor: '#00000000', color: '#fff', border: "0px"}
        });
    }

    function unblockPageUI() {
        $.unblockUI();
    }

    function blockPreview() {
        $('.preview-tableau').block({
            message: '<img src="@{'public/images/busy2.gif'}" width="50" height="50" /> Please Wait ....',
            baseZ: 2000, css: {backgroundColor: '#00000000', color: '#fff', border: "0px", fontSize: '30px'},
            overlayCSS: {opacity: 1}
        });
    }

    function unblockPreview() {
        $('.preview-tableau').unblock();
    }

    function uploadImage(image, editor, welEditable) {
        var data = new FormData();
        data.append("image", image);
        $.ajax({
            xhr: function () {
                var browser = navigator.appName;
                if (browser == "Microsoft Internet Explorer") {
                    var xhr = new window.ActiveXObject("Microsoft.XMLHTTP");
                } else {
                    var xhr = new window.XMLHttpRequest();
                }
                xhr.upload.addEventListener("progress", function (evt) {
                    if (evt.lengthComputable) {
                        var percentComplete = (evt.loaded / evt.total) * 100 + " %";
                        $('progress').attr({value: evt.loaded, max: evt.total});
                    }
                }, false);
                return xhr;
            },
            data: data,
            cache: false,
            contentType: false,
            processData: false,
            type: "post",
            url: "#{url route.cms_contentapicontroller_storepicture /}",
            beforeSend: function () {
                blockInsertPicture();
                $(window).bind("beforeunload", function (e) {
                    return e.originalEvent.returnValue;
                });
            },
            success: function (result) {
                var url = location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : '') + result.payload;
                var image = $('<img>').attr('src', url);
                $('#content').summernote("insertNode", image[0]);
            },
            complete: function () {
                unblockPicture();
                $('progress').attr('value', '0.0');
                $(window).unbind("beforeunload");
            },
            error: function (result) {
                unblockPicture();
                $('.alert-modal')
                        .addClass('alert-danger')
                        .removeClass('alert-success')
                        .removeClass('hidden').html('&{translation.general_error}');
            }
        });
    }

    function deleteImage(src) {
        var data = new FormData();
        var filename = src.replace(/.*(\/|\\)/, '');
        data.append("image", filename);
        $.ajax({
            xhr: function () {
                var browser = navigator.appName;
                if (browser == "Microsoft Internet Explorer") {
                    var xhr = new window.ActiveXObject("Microsoft.XMLHTTP");
                } else {
                    var xhr = new window.XMLHttpRequest();
                }
                xhr.upload.addEventListener("progress", function (evt) {
                    if (evt.lengthComputable) {
                        var percentComplete = (evt.loaded / evt.total) * 100 + " %";
                        $('progress').attr({value: evt.loaded, max: evt.total});
                    }
                }, false);
                return xhr;
            },
            data: data,
            cache: false,
            contentType: false,
            processData: false,
            type: "post",
            url: "#{url route.cms_contentapicontroller_deletepicture /}",
            beforeSend: function () {
                blockDeletePicture();
            },
            success: function (result) {
            },
            complete: function () {
                unblockPicture();
            },
            error: function (result) {
                unblockPicture();
                $('.alert-modal')
                        .addClass('alert-danger')
                        .removeClass('alert-success')
                        .removeClass('hidden').html('&{translation.general_error}');
            }
        });
    }

    function setDataAndChangeTab(result) {
        $('.tabular .item').removeClass('disabled')
        $('.tabular .item').tab('change tab', 'two')
        $('input[name="accessForm.id"]').val(result.id)
        $('input[name="model.id"]').val(result.id)
        $('input[name="accessForm.kldiId"]').val(result.kldi)
    }

    const validate_function = function (element) {
        if (!$(element).hasClass('note-editable')) {
            $(element).valid()
        } else {
            element = $(element).parent().parent().parent().find('textarea');
            $(element).valid();
        }
    }

    function removeErrorOnChange(selector) {
        let element = $(selector)
        if (element.css('display') !== 'none') {
            element.hide()
            element.parent().removeClass('has-error')
        }
    }

    var status = $('#statusAction').val();

    var baseValidationOptions = {
        rules: {
            "model.title": "required",
            "model.kldi_id": {"required": ('${!isUser}' === 'true')},
            "model.uploadfile": {"required": (status === 'create')},
            "model.content": "required",
            "model.publish": "required"
        },
        messages: {
            "model.title": "Judul belum diisi",
            "model.kldi_id": "Daftar K/L/P/D belum dipilih",
            "model.uploadfile": "File belum dipilih",
            "model.content": "Konten belum diisi",
            "model.publish": "Status publish belum dipilih"
        }
    }

    function isSummernoteEmpty(selector) {
        return $(selector).summernote('isEmpty')
    }

    function validateTextAreaWithSummer(selector) {
        let status = isSummernoteEmpty(selector)
        if (status) {
            let element = $("." + selector.replace(/(\.|\#)/g, '') + "-error")
            element.parent().parent().addClass('has-error')
            element.show()
            element.html('Belum diisi!')
        }
        return status
    }

    function generateAttachMoreElement(selector, title, moreSelector) {
        var moreUploadTag = '';
        let divUpload = '.div' + selector
        moreUploadTag += '<div class="row">';
        moreUploadTag += '<label for="' + selector + '" class="col-2 control-label">' + title.toUpperCase() + '</label>';
        moreUploadTag += '<div class="form-row col-10"><div class="form-group col-11">'
        moreUploadTag += '<input type="file" name="model.' + selector + '[]" '
                + ' class="form-control ' + selector + '" '
                + ' accept="' + acceptDocuments + '" '
                + ' placeholder="Silahkan pilih file yang akan diupload">';
        moreUploadTag += '<span class="form-control-feedback">File yang boleh diupload adalah pdf dengan ukuran maksimal ' + max_size_text + '</span>'
        moreUploadTag += '</div><div class="form-group col-1">'
        moreUploadTag += '<button class="btn btn-danger del_file_' + selector + '" type="button" ><i class="pg-minus"></i></button>'
        moreUploadTag += '</div></div>'
        moreUploadTag += '<span class="form-control-feedback"></span>'
        moreUploadTag += '<span class="help-block">'
        moreUploadTag += "<strong>#{error 'model." + selector + "' /}</strong>"
        moreUploadTag += '</span>'

        moreUploadTag += '</div>';
        $('<div class="delete_file">' + moreUploadTag + '</div>').fadeIn('slow').appendTo(divUpload);
        $(moreSelector).detach().appendTo(divUpload);
    }

    function registerDeleteAttachment(selector, title) {
        $(document).on('click', selector, function (e) {
            e.preventDefault();
            if (!confirm("Anda yakin ingin menghapus file " + title + " ?")) {
                return false;
            } else {
                let dataValue = $(this).data('value')
                if (dataValue) {
                    deletedFiles.push(dataValue)
                }
                $(this).parent().parent().parent().parent().remove()
            }
        });
    }

    const checkFileSize = (file) => file.size <= max_file_size

    function registerFileChange(selector, moreButton) {
        $(selector).prop('accept', acceptDocuments)
        $('body').delegate(selector, 'change', function () {
            let myfile = $(this).val();
            myfile = myfile.replace(/\\/g, '/')
            let ext = myfile.split('.').pop();
            let type = documentExtensionText()
            if (!validDocument(ext) || !checkFileSize(this.files[0])) {
                let fileName = myfile.substring(myfile.lastIndexOf('/') + 1)
                alert(fileName + " tidak valid, File ekstensi yang didukung untuk diunggah adalah " + type + ", size maksimal " + max_size_text )
                $(this).val('')
                return
            }
            $(moreButton).show();
            $(this).valid()
        })
    }

    function appendFilesToFormBy(data, selector) {
        data.delete("model" + selector + "[]");
        let totalMou = $(selector).length
        let index = 0;
        for (var indexMou = 0; indexMou < totalMou; indexMou++) {
            let files = $(selector)[indexMou].files
            if (files.length == 1) {
                let file = files[0]
                let extmou = file.name.split('.').pop()
                if (documentExtensions.includes(extmou)) {
                    data.append("model" + selector + "[" + index + "]", file)
                    index++
                }
            }
        }
    }

    var ext;
    var uploadfile;

    $('#uploadfile').prop('accept', acceptImages)
    $('#uploadfile').on('change', function () {
        var myfile = $(this).val();
        ext = myfile.split('.').pop();
        if (validImage(ext)) {
            uploadfile = $('#uploadfile')[0].files[0];
        } else {
            alert("File ekstensi yang didukung untuk diunggah adalah jpg, jpeg atau png")
            uploadfile = 'undefined'
            $(this).val('')
        }
    })

</script>

    #{get 'tabContentScripts' /}
    #{get 'accessScripts' /}
#{/set}